
<template>
  <q-card-actions
    align="right"
  >
    <q-btn
      outline
      color="primary"
      @click="onNewItem"
      class="q-mr-sm q-mb-sm"
    >
      <translate>Add manure application</translate>
    </q-btn>
  </q-card-actions>

  <q-list
    v-if="items && items.length"
    separator
  >
    <q-item
      v-for="item in items"
      :key="item.id"
      clickable
      v-ripple
      @click="onEditItem(item)"
    >
      <q-item-section
        side
      >
        <q-icon
          name="las la-poo"
        />
      </q-item-section>

      <q-item-section class="text-body2">
        <q-item-label lines="1">
          {{ item.month.label }}: {{ item.storedMonths }} <translate>months</translate>
        </q-item-label>
      </q-item-section>

      <q-item-section
        side
        top
      >
        <q-icon
          name="las la-angle-right"
          class="q-mt-auto q-mb-auto"
        />
      </q-item-section>
    </q-item>
  </q-list>

  <q-dialog
    v-model="openEditDialog"
    persistent
  >
    <IcpaPmnManureApplicationEditForm
      :id="editedItemId"
      :initial-month="editedItemMonth"
      :initial-stored-months="editedItemStoredMonths"
      :existing-items="items"
      @save="onSaveItem"
      @delete="onDeleteItem"
      @cancel="onCancelItem"
    />
  </q-dialog>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import IcpaPmnManureApplicationEditForm from 'src/pages/fieldbook/fertilization/algorithms/icpa-pmn/components/IcpaPmnManureApplicationEditForm'

export default {
  name: 'IcpaPmnManureApplicationsCard',
  mixins: [
    PlatformMixin,
    DateMixin
  ],
  components: {
    IcpaPmnManureApplicationEditForm
  },
  props: {
    initialItems: {
      type: Array,
      required: true
    }
  },
  emits: ['update-items'],
  data () {
    return {
      items: [...this.initialItems],
      openEditDialog: false,
      editedItem: null
    }
  },
  computed: {
    editedItemId () {
      return this.editedItem?.id
    },
    editedItemMonth () {
      return this.editedItem?.month
    },
    editedItemStoredMonths () {
      return this.editedItem?.storedMonths
    }
  },
  methods: {
    onEditItem (item) {
      this.editedItem = item
      this.openEditDialog = true
    },
    onNewItem () {
      this.openEditDialog = true
    },
    onSaveItem (item) {
      if (item.id) {
        this.onUpdateItem(item)
      } else {
        this.onCreateItem(item)
      }
    },
    onCreateItem (item) {
      // add a temporary id to allow edition in the list before saving it
      this.items.push({ ...item, id: new Date().getTime() })
      this.openEditDialog = false
      this.editedItem = null
      this.$emit('update-items', this.items)
    },
    onUpdateItem (item) {
      for (let i = 0; i < this.items.length; i++) {
        if (this.items[i].id === item.id) {
          this.items.splice(i, 1, item)
          break
        }
      }
      this.openEditDialog = false
      this.editedItem = null
      this.$emit('update-items', this.items)
    },
    onDeleteItem (id) {
      for (let i = 0; i < this.items.length; i++) {
        if (this.items[i].id === id) {
          this.items.splice(i, 1)
          break
        }
      }
      this.openEditDialog = false
      this.editedItem = null
      this.$emit('update-items', this.items)
    },
    onCancelItem () {
      this.openEditDialog = false
      this.editedItem = null
    }
  }
}

</script>
